#include "board.h"
#include "mc.h"
#include "spr_defs.h"

	.global ___main
        .section .stack, "aw", @nobits
.space  STACK_SIZE
_stack:

        .section .vectors, "ax"
        .org 0x100
_reset:
 
 
/* Cached Start */
			/* Flush IC & DC */
      	l.movhi r0, 0x0
        l.slli  r0,r0,16
        l.addi  r1,r0,0x0
        l.addi  r2,r0,0x0
        l.addi  r3,r0,0x0
        l.addi  r4,r0,0x0
        l.addi  r5,r0,0x0
        l.addi  r6,r0,0x0
        l.addi  r7,r0,0x0
        l.addi  r8,r0,0x0
        l.movhi  r9,0x5678
        l.addi  r9,r9,0x1234
        l.addi  r10,r0,0x0
        l.addi  r11,r0,0x0
        l.addi  r12,r0,0x0
        l.addi  r13,r0,0x0
        l.addi  r14,r0,0x0
        l.addi  r15,r0,0x0
        l.addi  r16,r0,0x0
        l.addi  r17,r0,0x0
        l.addi  r18,r0,0x0
        l.addi  r19,r0,0x0
        l.addi  r20,r0,0x0
        l.addi  r21,r0,0x0
        l.addi  r22,r0,0x0
        l.addi  r23,r0,0x0
        l.addi  r24,r0,0x0
        l.addi  r25,r0,0x0
        l.movhi r26,0x1234
        l.addi  r26,r26,0x5678
        l.addi  r27,r0,0x0
        l.addi  r28,r0,0x0
        l.addi  r29,r0,0x0
        l.addi  r30,r0,0x0
        l.addi  r31,r0,0x0
	l.addi	r10,r0,0
	l.addi	r11,r0,8192/2 /* 4096 TAK  */
loop:
	l.mtspr r0,r10,SPR_ICBIR
	l.mtspr r0,r10,SPR_DCBIR
	l.sfne	r10,r11
	l.bf	loop
	l.addi	r10,r10,16

	/* Enable IC & DC */
	l.addi	r10,r0,(SPR_SR_ICE|SPR_SR_DCE|SPR_SR_SUPV)
	l.mtspr	r0,r10,SPR_SR
	l.nop
	l.nop
	l.nop
	l.nop
	l.nop
/* Cached End */
        l.movhi r1,hi(0) /*TAK(_stack-4)  */
        l.ori   r1,r1,lo(0x3fe0) /*TAK Assuming 16KB memory (_stack-4) To avoid alignment error maximum stack area */
        l.addi  r2,r0,-3
        l.and   r1,r1,r2

        l.movhi r2,hi(_main)
        l.ori   r2,r2,lo(_main)
        l.jr    r2
        l.addi  r2,r0,0

___main:
	l.jr	r9
	l.nop
